"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Pool = function () {
    function Pool(maxWorkers) {
        _classCallCheck(this, Pool);

        this.running = 0;
        this.max = maxWorkers;
        this.queue = [];
    }

    _createClass(Pool, [{
        key: "isMaxedOut",
        value: function isMaxedOut() {
            return this.running >= this.max;
        }
    }, {
        key: "nextTask",
        value: function nextTask() {
            this.running--;
            this.runTask();
        }
    }, {
        key: "addTask",
        value: function addTask(payload) {
            this.queue.push(payload);
        }
    }, {
        key: "runTask",
        value: function runTask() {
            if (this.isMaxedOut() || this.queue.length == 0) {
                return;
            }

            this.running++;
            var task = this.queue.shift();
            task();
        }
    }, {
        key: "run",
        value: function run() {
            var startPoolThreadsCount = this.queue.length > this.max ? this.max : this.queue.length;

            for (var index = 0; index < startPoolThreadsCount; index++) {
                this.runTask();
            }
        }
    }]);

    return Pool;
}();

exports.default = Pool;